module;

#include <windows.h>

export module pige.winapi:application;

export import :window;

export namespace pige::winapi
{
	class error_app
	{
	private:
		pige::winapi::window m_window;

	public:
		inline error_app(HINSTANCE instance)
			: m_window{ instance, L"Hello Errors!" }
		{ }

		[[nodiscard]] int run()
		{
			MSG msg{};
			BOOL result;
			while (0 != (result = GetMessageW(&msg, nullptr, 0, 0)))
			{
				if (result < 0)
					throw winapi::winapi_error{};

				TranslateMessage(&msg);
				DispatchMessageW(&msg);
			}
			return static_cast<int>(msg.wParam);
		}
	};
}